rem SETTINGS
setlocal EnableDelayedExpansion

rem set next value to 1=yes, 0=no for 4K playfield
SET has4Kplayfield=1

rem set if you want 60fps on playfield recordings (1=yes, 0=no)
SET playfield60fps=0    

rem set next value to 1=nvidia gpu card (codec) 0=no-nvidia gpu card (cpu).
SET hasNVIDIA=1  

rem set the size in MB of bitrates used for recording. (HD=normal bigrate, PF=playfield bitrate)
SET HDbitrate=5
SET PFbitrate=10

rem Set RecAudio to record audio from pup#, NOTE you need to set following audio source too!
SET wAudio=-f dshow -i audio="Stereo Mix (Realtek(R) Audio)" -acodec libmp3lame
SET RECAUDIO=-1

rem  ******** dont change anything else in file below this line **************

rem 1=xpos,2=ypos,3=width,4=height,5=Pix,6=filename,7=screennum,8='display#',9=rotation
CD /d %~dp0
if exist recording.txt goto end
echo 1 >> recording.txt
playsound sounds\rec%7%.mp3
del ffmpeg*.log
del *.var
del stopplaying.txt

echo 1 >> recffmpeg.var

SET cbitrate=!HDbitrate!
if %has4Kplayfield%==1 (
  if %7%==3 SET cbitrate=!PFbitrate!
)

SET curFPS=30
if %playfield60fps%==1 (
  if %7%==3 SET curFPS=60
)

if NOT %7%==!RECAUDIO! (
  SET wAudio= 
)


if %hasNVIDIA%==0 (
if %7%==3 (
start /MIN "puprecord" ffmpeg -y -report -t 60 %wAudio% -filter_complex ddagrab=framerate=%curFPS%,hwdownload,format=bgra -c:v libx264 -r %curFPS% -preset ultrafast -crf 0 output.mkv
) else (
start /MIN "puprecord" ffmpeg -y -rtbufsize 100M -report %wAudio% -f gdigrab -framerate %curFPS% -t 60 -probesize 10M -offset_x %1 -offset_y %2 -video_size %3x%4 -i desktop -c:v libx264 -r %curFPS% -preset ultrafast -crf 0 -pix_fmt yuv420p output.mkv
)
)

if %hasNVIDIA%==1 (
if %7%==3 (
start /MIN "puprecord" ffmpeg -y -report -t 60 %wAudio% -filter_complex ddagrab=framerate=%curFPS%,hwdownload,format=bgra -c:v libx264 -r %curFPS% -preset ultrafast -crf 0 output.mkv
) else (
start /MIN "puprecord" ffmpeg -y -rtbufsize 100M -report %wAudio% -f gdigrab -t 60 -framerate %curFPS% -probesize 10M -offset_x %1 -offset_y %2 -video_size %3x%4 -i desktop -c:v h264_nvenc -preset:v fast -pix_fmt nv12 -r %curFPS% -b:v %cbitrate%M output.mkv
)
)


:end